package se.kth.android.projectred.QR.nonStandard;

import java.util.Arrays;

import org.opencv.core.Point;
import org.opencv.imgproc.Imgproc;

import android.util.Log;

public class FinderPatternFinder {

	public FinderPattern fPattern[] = new FinderPattern[4];
	public FinderPattern fPatternTemp[] = new FinderPattern[10];
	boolean img[][];
	boolean flag;
	byte counter_pattern;
	// For center
	int center_point[] = new int[100];
	int pattern_size[] = new int[100];
	int num;


	double distance(FinderPattern p1, FinderPattern p2){
		/*Distance between FinderPatterns
		 * Attention it's the square of the distance
		 * @Thomas
		 */
		return Math.pow((p1.row-p2.row),2)+Math.pow((p1.col-p2.col), 2);
	}
	
	void sortPatterns(){
		/*Sorts the FinderPatterns so they are in the following order: 1	2
		 * @Thomas
		 * 															   3	4
		 */
		
		int row[] = new int[4];
		int col[] = new int[4];
		/*
		goal[0] = new Point(60, 60);
		goal[1] = new Point(240, 60);
		goal[2] = new Point(60, 240);
		goal[3] = new Point(240,240);
		*/
		for (int i=0;i<4;i++){
			row[i]=fPattern[i].row;
			col[i]=fPattern[i].col;
		}
		
		int row_sort[] = row.clone();
		int col_sort[] = col.clone();
		Arrays.sort(row_sort);
		Arrays.sort(col_sort);
		
		FinderPattern[] fTemp = new FinderPattern[4];
		for (int i=0;i<4;i++){
			//top left
			if ((fPattern[i].row==row_sort[0]||fPattern[i].row==row_sort[1])
					&&(fPattern[i].col==col_sort[0]||fPattern[i].col==col_sort[1]))
				fTemp[0]=fPattern[i];
			//top right
			if ((fPattern[i].row==row_sort[0]||fPattern[i].row==row_sort[1])
					&&(fPattern[i].col==col_sort[2]||fPattern[i].col==col_sort[3]))
				fTemp[2]=fPattern[i];
			//bottom left
			if ((fPattern[i].row==row_sort[2]||fPattern[i].row==row_sort[3])
					&&(fPattern[i].col==col_sort[0]||fPattern[i].col==col_sort[1]))
				fTemp[1]=fPattern[i];
			//bottom right
			if ((fPattern[i].row==row_sort[2]||fPattern[i].row==row_sort[3])
					&&(fPattern[i].col==col_sort[2]||fPattern[i].col==col_sort[3]))
				fTemp[3]=fPattern[i];
			
		}
		
		fPattern=fTemp.clone();
//TODO: WORK IN PROGRESS
		
	
	}
	
	public FinderPatternFinder(boolean[][] imgBW) {

		img = imgBW;
		flag = false;
		counter_pattern = 1;
	}

	public boolean find() {
		/*
		 * Main function
		 * 
		 * @Thomas
		 */
		byte patternNR = 0;
		for (int row = 0; row < img.length; row++) {
			// Go through rows
			if (center(getRow(row)) > 0) {
				//Log.d("1234", "Found something in row:" + row + " at " + center_point[0]);
				// check every hit
				int center_row[]=center_point.clone();
				int num_row=num;
				for (int x = 0; x < num_row; x++) {
					
					if(center(getCol(center_row[x]))>0){
						//Found somethin in Collum
						
						for (int y=0;y<num;y++){
							int distance=Math.abs(center_point[y]-row);
							//Log.i("1234", "ROW FOUND: " + center_row[x] + " " + row+ "  length " + pattern_size[x]);

							if (distance==0){
								int center_col[]=center_point.clone();
								
								//Save Point
								//if (patternNR<4){
									fPatternTemp[patternNR++] = new FinderPattern(center_row[x],center_col[y],pattern_size[y]);
									Log.i("1234", "CENTER: " + center_row[x] + " " + center_col[y]+ "  length " + fPatternTemp[patternNR-1].center_size);
									//fPattern[patternNR].row=center_col[y];
									//fPattern[patternNR].col=center_row[x];
									//fPattern[patternNR].center_size=pattern_size[y];
									//patternNR++;
								//}else
								//	return false; //Found too many points
							}
						}
					}
				}
			}
		}
		if (patternNR==4){
			fPattern=fPatternTemp;
				sortPatterns();
				return true;
		}else if(patternNR>4){
			Log.e("1234", "Too many patterns detected");
			//if(fixTooMany()){
			//sortPatterns();
			return false;
			//}
			
		}
		Log.e("1234", "Found " + patternNR + "FPs and STOPPING decoding!");
			return false;
	}
/**	
boolean fixTooMany(){
	
    int size[] = new int[fPatternTemp.length];
	//Keep the biggest 4 patterns
	for (int i=0;i<fPatternTemp.length;i++) {


		
	int size_sort[] = size.clone();
		Arrays.sort(size_sort);
		int min=size_sort[size_sort.length-1-4];
		int max=size_sort[size_sort.length-1];
		int num=0;
		for (int k=0;k<fPatternTemp.length;k++){
			if(fPatternTemp[k].center_size<=max&&fPatternTemp[k].center_size>=min){
				if (num>4)
					return false;
				fPattern[num++]=fPatternTemp[k];
			}
		}
	return true;
	
}**/
	
	boolean[] getRow(int row) {
		/*Returns a row
		 * @Thomas
		 */
	//	boolean[] r = new boolean[img[0].length];
	//	for (int i = 0; i < img[0].length; i++)
	//		r[i] = img[row][i];
	//	return r;
		return img[row];
	}

	boolean[] getCol(int col) {
		/*Returns a colum
		 * @Thomas
		 */
		boolean[] r = new boolean[img.length];
		for (int i = 0; i < img.length; i++)
			r[i] = img[i][col];
		return r;

	}

	int center(boolean row_image[]) {
		/*
		 * finds the center of the 11311 ratio returns the number of centers
		 * found
		 * 
		 * @Thomas
		 */
		num = 0; // Counter of points found

	    Ratio ratio = new Ratio(row_image,true);

		for (int j = 0; j < ratio.getLength() - 4; j++) {
			// Go through the row to check for ratio
			if (ratio.isPattern(j)) {
				center_point[num] = ratio.findCenterPixel(j);
				pattern_size[num++] = ratio.getLength(); //TODO WRONG

			}
		}

		return num;
	}

}
